podTemplate(yaml: """
apiVersion: v1
kind: Pod
spec:
  serviceAccountName: jenkins-admin
  containers:
  - name: node
    image: node:14-alpine
    command: ['cat']
    tty: true
  - name: kubectl
    image: gcr.io/cloud-builders/kubectl
    command: ['cat']
    tty: true
  - name: docker
    image: docker:1.11
    command: ['cat']
    tty: true
    volumeMounts:
    - name: dockersock
      mountPath: /var/run/docker.sock
  volumes:
  - name: dockersock
    hostPath:
      path: /var/run/docker.sock
  nodeSelector:
    kubernetes.io/hostname: worker-2
"""
  ) {

  def image = "esparta86project/react"
  def registry = "gcr.io"
  def registryCredential = 'gcr:esparta86project'
  def imageName = 'esparta86project/react'
  def dockerImage = ''
  def namespace = "devops-tools"
  node(POD_LABEL) {
      stage('Git checkout') { 
            checkout scm           
            container('node') {
                sh 'hostname'
                sh 'ls -l'
            }
        }
        /*stage('Unit Test') {
            container('node') {
                sh 'set -xe ;apk add --no-cache yarn'
                sh 'npm install -g @nestjs/cli'
                sh 'yarn install --immutable'
                sh 'yarn test'
            }
        }*/
        stage('Building image') {
            container('docker') {
                script {
                    dockerImage = docker.build imageName + ":${env.BUILD_NUMBER}"
                }
            }
        }
        stage('Push Docker Image'){
            container('docker') {
                script {
                    docker.withRegistry("https://" + registry, registryCredential) {
                        dockerImage.push("${env.BUILD_NUMBER}")
                        dockerImage.push("latest")
                    }
                }
            }
        }
        stage('Deploy in k8s'){
            container('kubectl') {
                sh "kubectl set image deployment/test-api test-api=" + registry + "/" + imageName + ":" + "${env.BUILD_NUMBER}" + " --record --namespace=" + namespace
            }
        }
  }
}
